routes/web.php
<?php

use Illuminate\Support\Facades\Route,
    App\Http\Controllers\PostController,
    App\Http\Controllers\HomeController;

/*
|--------------------------------------------------------------------------
| Web Routes
|--------------------------------------------------------------------------
|
| Here is where you can register web routes for your application. These
| routes are loaded by the RouteServiceProvider within a group which
| contains the "web" middleware group. Now create something great!
|
*/

Route::get('/', [PostController::class, 'index']);
Route::resource('posts', PostController::class);
Auth::routes();

Route::get('/home', [HomeController::class, 'index'])->name('home');


/*Route::get('/posts/', [PostController::class, 'index'])->name('post.index');
Route::get('/posts/create', [PostController::class, 'create'])->name('post.create');
Route::get('/posts/show/{id}', [PostController::class, 'show'])->name('post.show');
Route::get('/posts/edit/{id}', [PostController::class, 'edit'])->name('post.edit');
Route::patch('/posts/show/{id}', [PostController::class, 'update'])->name('post.update');
Route::delete('/posts/destroy/{id}', [PostController::class, 'destroy'])->name('post.destroy');
Route::post('/posts', [PostController::class, 'store'])->name('post.store');*/

app/Models/Post.php
<?php

namespace App\Models;

use Illuminate\Database\Eloquent\Factories\HasFactory;
use Illuminate\Database\Eloquent\Model;

class Post extends Model
{
    use HasFactory;
}

app/Models/User.php
<?php

namespace App\Models;

use Illuminate\Contracts\Auth\MustVerifyEmail;
use Illuminate\Database\Eloquent\Factories\HasFactory;
use Illuminate\Foundation\Auth\User as Authenticatable;
use Illuminate\Notifications\Notifiable;
use Laravel\Sanctum\HasApiTokens;

class User extends Authenticatable
{
    use HasApiTokens, HasFactory, Notifiable;

    /**
     * The attributes that are mass assignable.
     *
     * @var array<int, string>
     */
    protected $fillable = [
        'name',
        'email',
        'password',
    ];

    /**
     * The attributes that should be hidden for serialization.
     *
     * @var array<int, string>
     */
    protected $hidden = [
        'password',
        'remember_token',
    ];

    /**
     * The attributes that should be cast.
     *
     * @var array<string, string>
     */
    protected $casts = [
        'email_verified_at' => 'datetime',
    ];
}

app/Http/Controllers/Controller.php
<?php

namespace App\Http\Controllers;

use Illuminate\Foundation\Auth\Access\AuthorizesRequests;
use Illuminate\Foundation\Bus\DispatchesJobs;
use Illuminate\Foundation\Validation\ValidatesRequests;
use Illuminate\Routing\Controller as BaseController;

class Controller extends BaseController
{
    use AuthorizesRequests, DispatchesJobs, ValidatesRequests;
}

app/Http/Controllers/HomeController.php
<?php

namespace App\Http\Controllers;

use Illuminate\Http\Request;

class HomeController extends Controller
{
    /**
     * Create a new controller instance.
     *
     * @return void
     */
    public function __construct()
    {
        $this->middleware('auth');
    }

    /**
     * Show the application dashboard.
     *
     * @return \Illuminate\Contracts\Support\Renderable
     */
    public function index()
    {
        return view('home');
    }
}

app/Http/Controllers/PostController.php
<?php

namespace App\Http\Controllers;

use App\Http\Requests\PostRequest;
use App\Models\Post;
use Illuminate\Http\Request;
use Illuminate\Support\Str;
use Illuminate\Support\Facades\Storage;

class PostController extends Controller
{
    public function __construct()
    {
        $this->middleware('auth')->except('index','show');
    }

    /**
     * Display a listing of the resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function index(Request $request)
    {
        $search = $request->search ?? '';

        if ($search) {
            $posts = Post::Join('users','author_id','=','users.id')
                //->select('posts.id as id')
                ->where('title','like','%'.$search.'%')
                ->orWhere('description','like','%'.$search.'%')
                ->orWhere('name','like','%'.$search.'%')
                ->orderBy('posts.created_at','desc')
                ->paginate(6);

        } else {
            $posts = Post::Join('users','author_id','=','users.id')
                ->select('*','posts.id as id')
                ->orderBy('posts.created_at','desc')
                ->paginate(6);
        }

        return view('posts.index', compact('posts','search'));
    }

    /**
     * Show the form for creating a new resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function create()
    {
        return view('posts.create',['post' => null]);
    }

    /**
     * Store a newly created resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @return \Illuminate\Http\Response
     */
    public function store(PostRequest $request)
    {
        $post = New Post();
        $post->title = $request->title;
        $post->short_title = Str::length($request->title)>30 ? Str::substr($request->title,0,30).'...' : $request->title;
        $post->description = $request->description;
        $post->author_id = \Auth::User()->id;

        if ($request->file('image')) {
            $path = Storage::putFile('public', $request->file('image'));
            $post->image = Storage::url($path);
        }
        $post->save();

        return redirect()->route('posts.index')->with('success','Пост '.$request->title.' успешно создан');
    }

    /**
     * Display the specified resource.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function show($id)
    {
        $post = Post::join('users','author_id','=','users.id')
            ->select('*','posts.id as id')
            ->find($id);

        if(empty($post))
            abort('404');

        return view('posts.show', compact('post'));
    }

    /**
     * Show the form for editing the specified resource.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function edit($id)
    {
        $post = Post::find($id);

        if (\Auth::User()->id != $post->author_id)
            return redirect()->route('posts.index')->withErrors('Вы не можете редактировать данную статью');

        return view('posts.edit', compact('post'));
    }

    /**
     * Update the specified resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function update(PostRequest $request, $id)
    {
        $post = Post::find($id);

        if (\Auth::User()->id != $post->author_id)
            return redirect()->route('posts.index')->withErrors('Вы не можете редактировать данную статью');

        $post->title = $request->title;
        $post->short_title = Str::length($request->title)>30 ? Str::substr($request->title,0,30).'...' : $request->title;
        $post->description = $request->description;

        if ($request->file('image')) {
            $path = Storage::putFile('public', $request->file('image'));
            $post->image = Storage::url($path);
        }
        $post->update();

        return redirect()->route('posts.show',['post'=> $id])->with('success','Пост '.$request->title.' успешно изменен');
    }

    /**
     * Remove the specified resource from storage.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function destroy($id)
    {
        $post = Post::find($id);

        if (\Auth::User()->id != $post->author_id)
            return redirect()->route('posts.index')->withErrors('Вы не можете редактировать данную статью');

        $post->delete();
        return redirect()->route('posts.index')->with('success','Пост успешно удален');
    }
}

resources/views/home.blade.php
@extends('layouts.app')

@section('content')
<div class="container">
    <div class="row justify-content-center">
        <div class="col-md-8">
            <div class="card">
                <div class="card-header">{{ __('Dashboard') }}</div>

                <div class="card-body">
                    @if (session('status'))
                        <div class="alert alert-success" role="alert">
                            {{ session('status') }}
                        </div>
                    @endif

                    {{ __('You are logged in!') }}
                </div>
            </div>
        </div>
    </div>
</div>
@endsection

resources/views/layouts/app.blade.php
<!doctype html>
<html lang="{{ str_replace('_', '-', app()->getLocale()) }}">
<head>
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width, initial-scale=1">

    <!-- CSRF Token -->
    <meta name="csrf-token" content="{{ csrf_token() }}">

    <title>{{ config('app.name', 'Laravel') }}</title>

    <!-- Scripts -->
    <script src="{{ asset('js/app.js') }}" defer></script>

    <!-- Fonts -->
    <link rel="dns-prefetch" href="//fonts.gstatic.com">
    <link href="https://fonts.googleapis.com/css?family=Nunito" rel="stylesheet">

    <!-- Styles -->
    <link href="{{ asset('css/app.css') }}" rel="stylesheet">
</head>
<body>
    <div id="app">
        <nav class="navbar navbar-expand-md navbar-light bg-white shadow-sm">
            <div class="container">
                <a class="navbar-brand" href="{{ url('/') }}">
                    {{ config('app.name', 'Laravel') }}
                </a>
                <button class="navbar-toggler" type="button" data-bs-toggle="collapse" data-bs-target="#navbarSupportedContent" aria-controls="navbarSupportedContent" aria-expanded="false" aria-label="{{ __('Toggle navigation') }}">
                    <span class="navbar-toggler-icon"></span>
                </button>

                <div class="collapse navbar-collapse" id="navbarSupportedContent">
                    <!-- Left Side Of Navbar -->
                    <ul class="navbar-nav me-auto">

                    </ul>

                    <!-- Right Side Of Navbar -->
                    <ul class="navbar-nav ms-auto">
                        <!-- Authentication Links -->
                        @guest
                            @if (Route::has('login'))
                                <li class="nav-item">
                                    <a class="nav-link" href="{{ route('login') }}">{{ __('Login') }}</a>
                                </li>
                            @endif

                            @if (Route::has('register'))
                                <li class="nav-item">
                                    <a class="nav-link" href="{{ route('register') }}">{{ __('Register') }}</a>
                                </li>
                            @endif
                        @else
                            <li class="nav-item dropdown">
                                <a id="navbarDropdown" class="nav-link dropdown-toggle" href="#" role="button" data-bs-toggle="dropdown" aria-haspopup="true" aria-expanded="false" v-pre>
                                    {{ Auth::user()->name }}
                                </a>

                                <div class="dropdown-menu dropdown-menu-end" aria-labelledby="navbarDropdown">
                                    <a class="dropdown-item" href="{{ route('logout') }}"
                                       onclick="event.preventDefault();
                                                     document.getElementById('logout-form').submit();">
                                        {{ __('Logout') }}
                                    </a>

                                    <form id="logout-form" action="{{ route('logout') }}" method="POST" class="d-none">
                                        @csrf
                                    </form>
                                </div>
                            </li>
                        @endguest
                    </ul>
                </div>
            </div>
        </nav>

        <main class="py-4">
            @yield('content')
        </main>
    </div>
</body>
</html>

resources/views/layouts/layout.blade.php
<!DOCTYPE html>
<html lang="{{ str_replace('_', '-', app()->getLocale()) }}">
    <head>
        <meta charset="utf-8">
        <meta name="viewport" content="width=device-width, initial-scale=1">
        <link rel="icon" href="{{ url('img/favicon/favicon.ico') }}">
        <link rel="apple-touch-icon" sizes="180x180" href="{{ url('img/favicon/apple-touch-icon.png') }}">
        <link rel="icon" type="image/png" sizes="32x32" href="{{ url('img/favicon/favicon-32x32.png') }}">
        <link rel="icon" type="image/png" sizes="16x16" href="{{ url('img/favicon/favicon-16x16.png') }}">
        <link rel="manifest" href="{{ url('img/favicon/site.webmanifest') }}">
        <link href="{{ asset('css/app.css') }}" rel="stylesheet">
        <title>{{ $title ?? 'Блог Laravel' }}</title>

    </head>
    <body class="antialiased">

        <nav class="navbar navbar-expand-lg navbar-light bg-light">
            <div class="container-fluid">
                <a class="navbar-brand" href="/">
                    <img src="{{ asset('img/icon/logo.min.svg') }}" alt="logo" height="30" title="Главная">
                </a>
                <button class="navbar-toggler" type="button" data-bs-toggle="collapse" data-bs-target="#navbarSupportedContent"
                        aria-controls="navbarSupportedContent" aria-expanded="false" aria-label="Toggle navigation">
                    <span class="navbar-toggler-icon"></span>
                </button>
                <div class="collapse navbar-collapse" id="navbarSupportedContent">
                    <ul class="navbar-nav me-auto mb-2 mb-lg-0">
                        <li class="nav-item">
                            <a class="nav-link active" aria-current="page" href="/">Статьи</a>
                        </li>

                        <li class="nav-item dropdown">
                            <a class="nav-link dropdown-toggle" href="#" id="navbarDropdown" role="button"
                               data-bs-toggle="dropdown" aria-expanded="false">
                                Действия
                            </a>
                            <ul class="dropdown-menu" aria-labelledby="navbarDropdown">
                                <li><a class="dropdown-item" href="{{ route('posts.create') }}">Создать пост</a></li>
                                <li><a class="dropdown-item" href="#">Другое действие</a></li>
                                <li>
                                    <hr class="dropdown-divider">
                                </li>
                                <li><a class="dropdown-item" href="#">Другое действие 2</a></li>
                            </ul>
                        </li>
                    </ul>
                    <form action="{{ route('posts.index') }}" class="d-flex">
                        <input class="form-control me-2" type="search" name="search" placeholder="Поиск" aria-label="Поиск" value="{{ $_GET['search'] ?? '' }}">
                        <button class="btn btn-outline-success" type="submit">Найти</button>
                    </form>
                    <!-- Right Side Of Navbar -->
                    <ul class="navbar-nav ms-auto">
                        <!-- Authentication Links -->
                        @guest
                            @if (Route::has('login'))
                                <li class="nav-item">
                                    <a class="nav-link" href="{{ route('login') }}">{{ __('auth.Login') }}</a>
                                </li>
                            @endif

                            @if (Route::has('register'))
                                <li class="nav-item">
                                    <a class="nav-link" href="{{ route('register') }}">{{ __('auth.Register') }}</a>
                                </li>
                            @endif
                        @else
                            <li class="nav-item dropdown">
                                <a id="navbarDropdown" class="nav-link dropdown-toggle" href="#" role="button" data-bs-toggle="dropdown" aria-haspopup="true" aria-expanded="false" v-pre>
                                    {{ Auth::user()->name }}
                                </a>

                                <div class="dropdown-menu dropdown-menu-end" aria-labelledby="navbarDropdown">
                                    <a class="dropdown-item" href="{{ route('logout') }}"
                                       onclick="event.preventDefault();
                                                     document.getElementById('logout-form').submit();">
                                        {{ __('auth.Logout') }}
                                    </a>

                                    <form id="logout-form" action="{{ route('logout') }}" method="POST" class="d-none">
                                        @csrf
                                    </form>
                                </div>
                            </li>
                        @endguest
                    </ul>
                </div>
            </div>
        </nav>

        <div class="container content">
            @if($errors->any())
                @foreach($errors->all() as $error)
                <div class="alert alert-danger alert-dismissible fade show" role="alert">
                    {{ $error }}
                    <button type="button" class="btn-close" data-bs-dismiss="alert" aria-label="Закрыть"></button>
                </div>
                @endforeach
            @endif
            @if(session('success'))
                <div class="alert alert-success alert-dismissible fade show" role="alert">
                    {{ session('success') }}
                    <button type="button" class="btn-close" data-bs-dismiss="alert" aria-label="Закрыть"></button>
                </div>
            @endif

            @yield('content')

        </div>

        <footer class="footer d-flex justify-content-center align-items-center bg-dark text-light">
                <div class="container">
                    <div class="row">
                        <div class="col-12">
                            <div class="version text-center text-sm text-gray-500 sm:text-right sm:ml-0">
                                Laravel v{{ Illuminate\Foundation\Application::VERSION }} (PHP v{{ PHP_VERSION }})
                            </div>
                        </div>
                    </div>
                </div>
            </footer>
        <script src="{{ asset('js/app.js') }}" defer></script>
    </body>
</html>

resources/views/posts/create.blade.php
@extends('layouts.layout' , ['title' => 'Создание статьи'])

@section('content')
    <form action="{{ route('posts.store') }}" method="post" enctype="multipart/form-data">
        @csrf
        <h3>Создать статью</h3>
        @include('posts.parts.form')
        <button type="submit" class="btn btn-primary">Создать</button>
    </form>
@endsection

resources/views/posts/edit.blade.php
@extends('layouts.layout', ['title' => $post->short_title])

@section('content')
    <form action="{{ route('posts.update', ['post' => $post->id]) }}" method="post" enctype="multipart/form-data">
        @csrf
        @method('PATCH')
        <h3>Редактирование статьи</h3>
        @include('posts.parts.form')
        <button type="submit" class="btn btn-success">Сохранить</button>
        <a href="{{ route('posts.show', ['post' => $post->id]) }}" class="btn btn-primary">Назад</a>
    </form>
@endsection

resources/views/posts/index.blade.php
@extends('layouts.layout', ['title' => 'Главная'])

@section('content')

    @if($search)
        <div class="search-result mb-3">
            По запросу {{ $search }} найдено {{ count($posts) }} шт. статей
        </div>

    @endif

    <div class="row">
        @foreach($posts as $post)
            <div class="col-sm-4 mb-5">
                <?php // echo '<pre>',var_dump($post),'</pre>'; ?>
                <div class="card h-100">
                    <div class="card-header"><h4>{{ $post->short_title }}</h4></div>
                    <div class="card-body">
                        <div class="card-img" style="background-image: url({{ $post->image ?? asset('img/no_post.png') }})"></div>
                        <div class="card-author">Автор: {{ $post->name }}</div>
                        <a href="{{ route('posts.show',['post' => $post->id]) }}" class="btn btn-outline-primary">Посмотреть пост</a>
                    </div>
                </div>
            </div>
        @endforeach
    </div>

{{--    @if(isset($posts->pageName))--}}
        {{ $posts->links('vendor.pagination.bootstrap-4') }}
{{--    @endif--}}
@endsection

resources/views/posts/parts/form.blade.php
<div class="mb-3">
    <label for="titlePost" class="form-label">Название</label>
    <input type="text" class="form-control" id="titlePost" name="title" value="{{ old('title') ?? $post->title ?? '' }}">
</div>
<div class="mb-3">
    <label for="descriptionPost" class="form-label">Текст статьи</label>
    <textarea type="text" rows="5" class="form-control" id="descriptionPost" name="description">{{ old('description') ?? $post->description ?? '' }}</textarea>
</div>
<div class="mb-3">
    <label for="imagePost" class="form-label">Изображение</label>
    <input type="file" class="form-control" id="imagePost" name="image">
    @if($post && $post->image)
        <img src="{{ $post->image }}" alt="Изображение">
    @endif
</div>

resources/views/posts/show.blade.php
@extends('layouts.layout', ['title' => $post->short_title])

@section('content')

    <div class="row">
        <div class="col-sm-12 mb-5">
            <div class="card h-100 {{ App::currentLocale() }}">
                <div class="card-header"><h4>{{ $post->title }}</h4></div>
                <div class="card-body">
                    <div class="card-img card-img__show" style="background-image: url({{ $post->image ?? asset('img/no_post.png') }})"></div>
                    <div class="card-description">
                        {{ $post->description }}
                    </div>
                    <div class="card-author">Автор: {{ $post->name }}</div>
                    <div class="card-date mb-3">
                        Опубликован: <span title="{{ $post->created_at->format('d.m.Y H:i:s') }}">
                            {{ $post->created_at->diffForHumans() }}
                        </span>
                    </div>
                    <div class="card-btn d-flex">
                        <a href="{{ route('posts.index') }}" class="btn btn-outline-primary me-2">На главную</a>
                        @auth()
                            @if(Auth::user()->id == $post->author_id)
                            <a href="{{ route('posts.edit',['post'=> $post->id]) }}" class="btn btn-outline-success me-2">Редактировать</a>
                            <form action="{{ route('posts.destroy', ['post'=> $post->id]) }}" method="post">
                                @csrf
                                @method('DELETE')
                                <button type="submit" class="btn btn-outline-danger">Удалить</button>
                            </form>
                            @endif
                        @endauth
                    </div>

                </div>
            </div>
        </div>
    </div>

@endsection